<?php
namespace Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Util\SupUtilities;

class CentralComprasController 
{

    protected $supUtilities;

    public function __construct(SupUtilities $supUtilities) 
    {
        $this->supUtilities = $supUtilities;
    }
    
	public function getCdFilCentCmp(DTO\Request $request, DTO\Response $response)
	{
        try {
            $row = $request->getRow();
            $centralDeCompras = $this->supUtilities->getCentralCompras();
            if(!$centralDeCompras) {
                throw new \Exception('CDFILCENTCMP_NOT_REGISTERED');
            }
            $response->addDataSet(new DataSet("data", $centralDeCompras));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }
}