<?php
namespace Modules\Cadastros\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Report\ReportService;

class MarcaReportController extends \Zeedhi\Framework\Controller\Report
{
	protected $connection;
	protected $qr2Strategy;
	protected $stNomeRel;
    protected $stExtensao;
    protected $birtStrategy;
    protected $environment;
	
	public function __construct($reportService, $connection, $qr2Strategy, $birtStrategy, $environment) {
		parent::__construct($reportService);
        $this->connection = $connection;
        $this->qr2Strategy = $qr2Strategy;
        $this->birtStrategy = $birtStrategy;
        $this->environment = $environment;
    }
    
    protected $reportMapping = array ();
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->stNomeRel = $this->getReportName($row);
        $row['NRORG'] = $this->environment->getNrOrg();
        $this->reportMapping[$this->stNomeRel] =
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDARVPRODINI' => 'P_CDPRODINI',
                'CDARVPRODFIN' => 'P_CDPRODFIN',
                'TPROD'        => 'P_TPROD',
                'CDMARCAINI'   => 'P_CDMARCINI',
                'CDMARCAFIN'   => 'P_CDMARCFIN',
                'NMMARCAFIN'   => 'P_NMMARCAFIN',
                'NMMARCAINI'   => 'P_NMMARCAINI',
                'NMPRODFIN'    => 'P_NMPRODFIN',
                'NMPRODINI'    => 'P_NMPRODINI',
                'NRORG'        => 'P_NRORG'    
            ),
        );
  
    }
}